<?xml version="1.0" encoding="UTF-8"?>
<mm:monitor xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:mm="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.2/mm" xmlns:xsd="http://www.w3.org/2001/XMLSchema-datatypes" xsi:schemaLocation="http://www.ibm.com/xmlns/prod/websphere/monitoring/6.0.2/mm monitor.xsd" displayName="ClipsAndTacks" id="ClipsAndTacks" timestamp="2006-11-26T12:45:08">
  <monitorDetailsModel displayName="ClipsAndTacks" id="MDM">
    <monitoringContext displayName="ClipsAndTacks MC" id="ClipsAndTacks_MC">
      <trigger displayName="Ship Order to Customer Trigger" id="Ship_Order_to_Customer_Trigger" isRepeatable="false" terminateContext="true">
      	<onEvent ref="Activity_Event"/>
      	<gatingCondition expression="Activity_Event/extendedData/ActivityEventData/activityName='Ship Order to Customer' and Activity_Event/extendedData/ActivityEventData/eventType='completed'"/>
      </trigger>
      <trigger displayName="Cancel Trigger" id="Cancel_Trigger" terminateContext="true">
      	<onEvent ref="Activity_Event"/>
      	<gatingCondition expression="Activity_Event/extendedData/ActivityEventData/activityName='Cancel Order and Send Notification' and Activity_Event/extendedData/ActivityEventData/eventType='completed'"/>
      </trigger>
      <trigger displayName="New Order Trigger" id="New_Order_Trigger">
      	<onEvent ref="New_Order_Event"/>
      	<gatingCondition expression="New_Order_Event/extendedData/ActivityEventData/activityName='Check Order Handling Policy for Automatic Approval' and New_Order_Event/extendedData/ActivityEventData/eventType='started'"/>
      </trigger>
      <inboundEvent displayName="Activity Event" id="Activity_Event" multipleCorrelationMatches="raiseException" noCorrelationMatches="raiseException" oneCorrelationMatch="deliverEvent" type="ActivityEvent">
      	<correlationPredicate expression="ClipsAndTacks_Key=Activity_Event/extendedData/OrderBOData/orderNumber"/>
      	<filter expression="Activity_Event/extendedData/ActivityEventData/businessUnit = 'Clips And Tacks' and Activity_Event/extendedData/ActivityEventData/processName = 'Order Handling'"/>
      </inboundEvent>
      <inboundEvent displayName="New Order Event" id="New_Order_Event" multipleCorrelationMatches="raiseException" noCorrelationMatches="createNewContext" oneCorrelationMatch="raiseException" type="NewOrderEvent">
      	<correlationPredicate expression="ClipsAndTacks_Key=New_Order_Event/extendedData/OrderBOData/orderNumber"/>
      	<filter expression="New_Order_Event/extendedData/ActivityEventData/businessUnit='Clips And Tacks' and New_Order_Event/extendedData/ActivityEventData/processName='Order Handling'"/>
      </inboundEvent>
      <metric displayName="ClipsAndTacks Key" id="ClipsAndTacks_Key" type="xsd:string" isPartOfKey="true">
      	<map>
      		<outputValue>
      			<singleValue expression="New_Order_Event/extendedData/OrderBOData/orderNumber"/>
      		</outputValue>
      	</map>
      </metric>
      <metric displayName="Order Start Time" id="Order_Start_Time" type="xsd:dateTime">
      	<map>
      		<trigger ref="New_Order_Trigger"/>
      		<outputValue>
      			<singleValue expression="New_Order_Event/extendedData/ActivityEventData/startTime"/>
      		</outputValue>
      	</map>
      </metric>
      <metric displayName="Order End Time" id="Order_End_Time" type="xsd:dateTime">
      	<map>
      		<trigger ref="Cancel_Trigger"/>
      		<outputValue>
      			<singleValue expression="Activity_Event/extendedData/ActivityEventData/endTime"/>
      		</outputValue>
      	</map>
      	<map>
      		<trigger ref="Ship_Order_to_Customer_Trigger"/>
      		<outputValue>
      			<singleValue expression="Activity_Event/extendedData/ActivityEventData/endTime"/>
      		</outputValue>
      	</map>
      </metric>
      <metric displayName="Order Fulfillment Duration" id="Order_Fulfillment_Duration" type="xsd:duration">
      	<map>
      		<trigger ref="Cancel_Trigger"/>
      		<outputValue>
      			<singleValue expression="Order_End_Time - Order_Start_Time"/>
      		</outputValue>
      	</map>
      	<map>
      		<trigger ref="Ship_Order_to_Customer_Trigger"/>
      		<outputValue>
      			<singleValue expression="Order_End_Time - Order_Start_Time"/>
      		</outputValue>
      	</map>
      	<defaultValue>
      		<singleValue expression="duration('P0DT0H0M0.000S')"/>
      	</defaultValue>
      </metric>
      <metric displayName="Order Status" id="Order_Status" type="xsd:string">
      	<map>
      		<trigger ref="Cancel_Trigger"/>
      		<outputValue>
      			<singleValue expression="'Cancelled'"/>
      		</outputValue>
      	</map>
      	<map>
      		<trigger ref="Ship_Order_to_Customer_Trigger"/>
      		<outputValue>
      			<singleValue expression="'Shipped'"/>
      		</outputValue>
      	</map>
      	<defaultValue>
      		<singleValue expression="'New'"/>
      	</defaultValue>
      </metric>
      <metric displayName="Ship Percentage" id="Ship_Percentage" type="xsd:integer">
      	<map>
      		<trigger ref="Ship_Order_to_Customer_Trigger"/>
      		<outputValue>
      			<singleValue expression="100"/>
      		</outputValue>
      	</map>
      	<defaultValue>
      		<singleValue expression="0"/>
      	</defaultValue>
      </metric>
      <metric displayName="country" id="country" type="xsd:string">
      	<map>
      		<trigger ref="New_Order_Trigger"/>
      		<outputValue>
      			<singleValue expression="New_Order_Event/extendedData/OrderBOData/country"/>
      		</outputValue>
      	</map>
      </metric>
      <metric displayName="city" id="city" type="xsd:string">
      	<map>
      		<trigger ref="New_Order_Trigger"/>
      		<outputValue>
      			<singleValue expression="New_Order_Event/extendedData/OrderBOData/city"/>
      		</outputValue>
      	</map>
      </metric>
      <metric displayName="totalPrice" id="totalPrice" type="xsd:decimal">
      	<map>
      		<trigger ref="New_Order_Trigger"/>
      		<outputValue>
      			<singleValue expression="New_Order_Event/extendedData/OrderBOData/totalPrice"/>
      		</outputValue>
      	</map>
      	<defaultValue>
      		<singleValue expression="0"/>
      	</defaultValue>
      </metric>
      <counter displayName="Ship Counter" id="Ship_Counter" type="xsd:integer">
      	<incrementedWhen ref="Ship_Order_to_Customer_Trigger"/>
      </counter>
      <stopwatch displayName="Monitoring Context Timer" id="Monitoring_Context_Timer" type="xsd:duration">
      	<startedWhen ref="New_Order_Trigger"/>
      	<stoppedWhen ref="Cancel_Trigger"/>
      	<stoppedWhen ref="Ship_Order_to_Customer_Trigger"/>
      </stopwatch>
    </monitoringContext>
  </monitorDetailsModel>
  <kpiModel displayName="ClipsAndTacks" id="KM">
  	<kpiContext displayName="My KPI Context" id="My_KPI_Context">
  		<trigger displayName="Declined Order Trigger" id="Declined_Order_Trigger">
  			<evaluationTime minutes="1" days="0" hours="0"/>
  			<gatingCondition expression="Declined_Order_KPI&gt;=3"/>
  		</trigger>
  		<trigger displayName="Order Fulfillment Timer Trigger" id="Order_Fulfillment_Timer_Trigger">
  			<evaluationTime minutes="1"/>
  			<gatingCondition expression="Average_Order_Fulfillment_KPI_August_2006 ge duration('P3DT1H')"/>
  		</trigger>
  		<outboundEvent displayName="Declined Order Outbound Event" id="Declined_Order_Outbound_Event" type="DeclinedOrderEvent">
  			<map>
  				<trigger ref="Declined_Order_Trigger"/>
  				<outputValue>
  					<assignments>
  						<assignment leftValue="Declined_Order_Outbound_Event/extendedData/BusinessSituationName" rightValue="'Too many orders have been declined'"/>
  					</assignments>
  				</outputValue>
  			</map>
  		</outboundEvent>
  		<outboundEvent displayName="Order Fulfillment Outbound Event" id="Order_Fulfillment_Outbound_Event" type="LateAverageOrderShippedEvent">
  			<map>
  				<trigger ref="Order_Fulfillment_Timer_Trigger"/>
  				<outputValue>
  					<assignments>
  						<assignment leftValue="Order_Fulfillment_Outbound_Event/extendedData/BusinessSituationName" rightValue="'Average shipment is too late'"/>
  						<assignment leftValue="Order_Fulfillment_Outbound_Event/extendedData/AverageOrderProcessingTime" rightValue="string(decimal(Average_Order_Fulfillment_KPI_August_2006) div 86400)"/>
  					</assignments>
  				</outputValue>
  			</map>
  		</outboundEvent>
  		<kpi displayName="Average Order Fulfillment KPI August 2006" id="Average_Order_Fulfillment_KPI_August_2006" type="xsd:duration">
  			<definition>
  				<cube ref="ClipsAndTacks_MC_Cube"/>
  				<measure ref="Average_Order_Fulfillment"/>
  				<dimension ref="Order_Status_Dimension">
  					<attribute ref="Order_Status_Dimension/Order_Status" value="Shipped"/>
  				</dimension>
  				<timeDimension ref="Start_Time_Dimension">
  					<fixedPeriod startDate="2006-08-01" endDate="2006-08-31"/>
  				</timeDimension>
  			</definition>
  			<target displayName="Target" id="Target" value="259200000">
  				<description></description>
  			</target>
  			<ranges displayName="Ranges" id="Ranges" rangeType="actualValue">
  				<description></description>
  				<range displayName="Day 1" id="Day_1">
  					<startValue displayName="startValue" id="startValue" value="0"></startValue>
  					<endValue displayName="endValue" id="endValue" value="86400000">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Day 2" id="Day_2">
  					<startValue displayName="startValue" id="startValue" value="86400000"></startValue>
  					<endValue displayName="endValue" id="endValue" value="172800000">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Day 3" id="Day_3">
  					<startValue displayName="startValue" id="startValue" value="172800000"></startValue>
  					<endValue displayName="endValue" id="endValue" value="259200000">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Day 4" id="Day_4">
  					<startValue displayName="startValue" id="startValue" value="259200000"></startValue>
  					<endValue displayName="endValue" id="endValue" value="345600000">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Day 5" id="Day_5">
  					<startValue displayName="startValue" id="startValue" value="345600000"></startValue>
  					<endValue displayName="endValue" id="endValue" value="432000000">
  						<description></description>
  					</endValue>
  				</range>
  			</ranges>
  		</kpi>
  		<kpi displayName="Percent of Orders Approved KPI" id="Percent_of_Orders_Approved_KPI" type="xsd:decimal">
  			<definition>
  				<cube ref="ClipsAndTacks_MC_Cube"/>
  				<measure ref="Average_Ship_Percentage"/>
  			</definition>
  			<target displayName="Target" id="Target" value="90"></target>
  			<ranges displayName="Ranges" id="Ranges" rangeType="actualValue">
  				<range displayName="High Range" id="High_Range">
  					<startValue displayName="startValue" id="startValue" value="90">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="100">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Low Range" id="Low_Range">
  					<startValue displayName="startValue" id="startValue" value="0">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="90">
  						<description></description>
  					</endValue>
  				</range>
  			</ranges>
  		</kpi>
  		<kpi displayName="Average Order Price (Dollars)" id="Average_Order_Price__x0028_Dollars_x0029_" type="xsd:decimal">
  			<definition>
  				<cube ref="ClipsAndTacks_MC_Cube"/>
  				<measure ref="Average_Order_Price"/>
  			</definition>
  			<target displayName="Target" id="Target" value="300"></target>
  			<ranges displayName="Ranges" id="Ranges" rangeType="actualValue">
  				<range displayName="High Range" id="High_Range">
  					<startValue displayName="startValue" id="startValue" value="300">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="1000">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Low Range" id="Low_Range">
  					<startValue displayName="startValue" id="startValue" value="0">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="300">
  						<description></description>
  					</endValue>
  				</range>
  			</ranges>
  		</kpi>
  		<kpi displayName="Declined Order KPI" id="Declined_Order_KPI" type="xsd:decimal">
  			<definition>
  				<cube ref="ClipsAndTacks_MC_Cube"/>
  				<measure ref="Order_Count"/>
  				<dimension ref="Order_Status_Dimension">
  					<attribute ref="Order_Status_Dimension/Order_Status" value="Cancelled"/>
  				</dimension>
  			</definition>
  			<target displayName="Target" id="Target" value="3"></target>
  			<ranges displayName="Ranges" id="Ranges" rangeType="actualValue">
  				<range displayName="High Range" id="High_Range">
  					<startValue displayName="startValue" id="startValue" value="3">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="10">
  						<description></description>
  					</endValue>
  				</range>
  				<range displayName="Low Range" id="Low_Range">
  					<startValue displayName="startValue" id="startValue" value="0">
  						<description></description>
  					</startValue>
  					<endValue displayName="endValue" id="endValue" value="3">
  						<description></description>
  					</endValue>
  				</range>
  			</ranges>
  		</kpi>
  	</kpiContext>
  </kpiModel>
  <dataMartModel displayName="ClipsAndTacks DMM" id="DMM">
    <cube displayName="ClipsAndTacks MC Cube" id="ClipsAndTacks_MC_Cube" monitoringContext="ClipsAndTacks_MC">
      <factTable displayName="ClipsAndTacks MC Fact Table" id="ClipsAndTacks_MC_Fact_Table">
        <attribute displayName="ClipsAndTacks Key Fact" id="ClipsAndTacks_Key_Fact" attributeSource="ClipsAndTacks_Key"/>
        <attribute displayName="Order End Time Fact" id="Order_End_Time_Fact" attributeSource="Order_End_Time"></attribute>
        <attribute displayName="Order Fulfillment Duration Fact" id="Order_Fulfillment_Duration_Fact" attributeSource="Order_Fulfillment_Duration"></attribute>
        <attribute displayName="Ship Percentage Fact" id="Ship_Percentage_Fact" attributeSource="Ship_Percentage"></attribute>
        <attribute displayName="totalPrice Fact" id="totalPrice_Fact" attributeSource="totalPrice"></attribute>
        <attribute displayName="Ship Counter Fact" id="Ship_Counter_Fact" attributeSource="Ship_Counter"></attribute>
        <attribute displayName="Monitoring Context Timer Fact" id="Monitoring_Context_Timer_Fact" attributeSource="Monitoring_Context_Timer"></attribute>
      </factTable>
      <measure displayName="Average Order Fulfillment" id="Average_Order_Fulfillment" aggregationType="avg" source="ClipsAndTacks_MC_Fact_Table/Order_Fulfillment_Duration_Fact"></measure>
      <measure displayName="Average Ship Percentage" id="Average_Ship_Percentage" aggregationType="avg" source="ClipsAndTacks_MC_Fact_Table/Ship_Percentage_Fact"></measure>
      <measure displayName="Sum Order Price" id="Sum_Order_Price" aggregationType="sum" source="ClipsAndTacks_MC_Fact_Table/totalPrice_Fact"></measure>
      <measure displayName="Order Count" id="Order_Count" aggregationType="count" source="ClipsAndTacks_MC_Fact_Table/ClipsAndTacks_Key_Fact"></measure>
      <measure displayName="Average Order Price" id="Average_Order_Price" aggregationType="avg" source="ClipsAndTacks_MC_Fact_Table/totalPrice_Fact"></measure>
      <dimension displayName="Start Time Dimension" id="Start_Time_Dimension">
      	<attribute displayName="Start Time" id="Start_Time" isPartOfDimensionKey="true" level="1" attributeSource="Order_Start_Time"></attribute>
      </dimension>
      <dimension displayName="Order Status Dimension" id="Order_Status_Dimension">
      	<attribute displayName="Order Status" id="Order_Status" isPartOfDimensionKey="true" level="1" attributeSource="Order_Status"></attribute>
      </dimension>
      <dimension displayName="Location" id="Location">
      	<attribute displayName="Country" id="Country" isPartOfDimensionKey="true" level="1" attributeSource="country"></attribute>
      	<attribute displayName="City" id="City" isPartOfDimensionKey="true" level="2" attributeSource="city"></attribute>
      </dimension>
    </cube>
  </dataMartModel>
  <eventModel id="EM">
  	<import location="ActivityEvent.cbe"/>
  	<import location="NewOrderEvent.cbe"/>
  	<import location="DeclinedOrderEvent.cbe"/>
  	<import location="LateAverageOrderShippedEvent.cbe"/>
  </eventModel>
</mm:monitor>